var Complex, Number;
var __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
  for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
  function ctor() { this.constructor = child; }
  ctor.prototype = parent.prototype;
  child.prototype = new ctor;
  child.__super__ = parent.prototype;
  return child;
};
Number = require('./number');
module.exports = Complex = (function() {
  __extends(Complex, Number);
  function Complex(re, im) {
    this.re = re;
    this.im = im;
  }
  Complex.zero = new Complex(0, 0);
  Complex.unit = new Complex(1, 0);
  Complex.add = function(a, b) {
    return new this(a.re + b.re, a.im + b.im);
  };
  Complex.neg = function(n) {
    return new this(-n.re, -n.im);
  };
  Complex.sub = function(a, b) {
    return new this(a.re - b.re, a.im - b.im);
  };
  Complex.mul = function(a, b) {
    return new this(a.re * b.re - a.im * b.im, a.re * b.im + a.im * b.re);
  };
  Complex.inv = function(n) {
    var norm2;
    norm2 = this.norm2(n);
    return new this(n.re / norm2, -n.im / norm2);
  };
  Complex.conj = function(n) {
    return new this(n.re, -n.im);
  };
  Complex.norm2 = function(n) {
    return n.re * n.re + n.im * n.im;
  };
  Complex.eq = function(a, b) {
    return (a.re === b.re) && (a.im === b.im);
  };
  return Complex;
})();