var Number, Rational;
var __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
  for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
  function ctor() { this.constructor = child; }
  ctor.prototype = parent.prototype;
  child.prototype = new ctor;
  child.__super__ = parent.prototype;
  return child;
};
Number = require('./number');
module.exports = Rational = (function() {
  var gcd;
  __extends(Rational, Number);
  function Rational(num, denom) {
    var d;
    if (denom == null) {
      denom = 1;
    }
    d = gcd(num, denom);
    this.num = num / d;
    this.denom = denom / d;
  }
  gcd = function(a, b) {
    var temp;
    while (b !== 0) {
      temp = a;
      a = b;
      b = temp % b;
    }
    return a;
  };
  Rational.zero = new Rational(0);
  Rational.unit = new Rational(1);
  Rational.add = function(a, b) {
    return new this(a.num * b.denom + b.num * a.denom, a.denom * b.denom);
  };
  Rational.neg = function(n) {
    return new this(-n.num, n.denom);
  };
  Rational.sub = function(a, b) {
    return new this(a.num * b.denom - b.num * a.denom, a.denom * b.denom);
  };
  Rational.mul = function(a, b) {
    return new this(a.num * b.num, a.denom * b.denom);
  };
  Rational.inv = function(n) {
    return new this(n.denom, n.num);
  };
  Rational.div = function(a, b) {
    return new this(a.num * b.denom, a.denom * b.num);
  };
  Rational.conj = function(n) {
    return n;
  };
  Rational.norm2 = function(n) {
    return (n.num * n.num) / (n.denom * n.denom);
  };
  Rational.eq = function(a, b) {
    return (a.num === b.num) && (a.denom === b.denom);
  };
  return Rational;
})();